function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["portal", "show", "animation", "duration", "list", "maskAttribute", "groupAttribute", "optionAttribute", "cancelCaption", "cancelAttribute", "onChange"],
  _excluded2 = ["onClick"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useContext } from 'react';
import { createPortal } from 'react-dom';
import Context from "./../../Context/instance.js";
import { createElement as _createElement } from "react";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Actionsheet = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    _ref$show = _ref.show,
    show = _ref$show === void 0 ? false : _ref$show,
    _ref$animation = _ref.animation,
    animation = _ref$animation === void 0 ? 'slideUp' : _ref$animation,
    duration = _ref.duration,
    list = _ref.list,
    _ref$maskAttribute = _ref.maskAttribute,
    maskAttribute = _ref$maskAttribute === void 0 ? {} : _ref$maskAttribute,
    _ref$groupAttribute = _ref.groupAttribute,
    groupAttribute = _ref$groupAttribute === void 0 ? {} : _ref$groupAttribute,
    _ref$optionAttribute = _ref.optionAttribute,
    optionAttribute = _ref$optionAttribute === void 0 ? {} : _ref$optionAttribute,
    _ref$cancelCaption = _ref.cancelCaption,
    cancelCaption = _ref$cancelCaption === void 0 ? '' : _ref$cancelCaption,
    _ref$cancelAttribute = _ref.cancelAttribute,
    cancelAttribute = _ref$cancelAttribute === void 0 ? {} : _ref$cancelAttribute,
    onChange = _ref.onChange,
    others = _objectWithoutProperties(_ref, _excluded);
  // context
  var context = useContext(Context) || {};
  var locale = context.locale || function (remark) {
    return remark || '';
  };
  function handleClick(e) {
    var target = e.target;
    // 获取值
    var item = null;
    var index = null;
    if (target.classList.contains('actionsheet-option')) {
      index = target.getAttribute('data-index');
      index = Number(index);
      item = list[index] || null;
    }
    if (item && item.onClick) {
      list[index].onClick(e, item.name, [item]);
      return;
    }
    // 区分点击事件
    e.stopPropagation();
    if (target.classList.contains('actionsheet-option')) {
      if (optionAttribute.onClick) {
        optionAttribute.onClick(e, item.name, [item]);
        return;
      }
    }
    if (target.classList.contains('actionsheet-group') && groupAttribute.onClick) {
      groupAttribute.onClick(e);
      return;
    }
    if (target.classList.contains('actionsheet-mask') && maskAttribute.onClick) {
      maskAttribute.onClick(e);
      return;
    }
    if (target.classList.contains('actionsheet-cancel') && cancelAttribute.onClick) {
      cancelAttribute.onClick(e);
      return;
    }
    if (target.classList.contains('actionsheet-option')) {
      if (onChange) onChange(e, item.name, [item], index);
    }
  }

  // 构建动画
  var animationClassName = '';
  switch (animation) {
    case 'slideLeft':
      animationClassName = 'popup-animation right-middle';
      break;
    case 'slideRight':
      animationClassName = 'popup-animation left-middle';
      break;
    case 'slideUp':
      animationClassName = 'popup-animation bottom-center';
      break;
    case 'slideDown':
      animationClassName = 'popup-animation top-center';
      break;
    case 'zoom':
      animationClassName = 'popup-animation middle';
      break;
    case 'fade':
      animationClassName = 'popup-animation middle';
      break;
    case 'none':
      animationClassName = '';
      break;
    default:
      animationClassName = 'popup-animation middle';
  }

  // 动画时长
  var durationStyle = {};
  if (typeof duration === 'number') {
    durationStyle = {
      WebkitTransitionDuration: duration + 'ms'
    };
  }

  // 过滤已经回调的属性
  function filterProps(props) {
    if (!props) return {};
    var onClick = props.onClick,
      otherProps = _objectWithoutProperties(props, _excluded2);
    return _objectSpread({}, otherProps);
  }

  // 剔除掉onClick事件, 因为在容器onClick已经回调了
  var otherMaskAttribute = filterProps(maskAttribute);
  var otherGroupAttribute = filterProps(groupAttribute);
  var otherOptionAttribute = filterProps(optionAttribute);
  var otherCancelAttribute = filterProps(cancelAttribute);
  return /*#__PURE__*/createPortal( /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({
    ref: ref
  }, otherMaskAttribute), {}, {
    className: "mask actionsheet-mask".concat(otherMaskAttribute.className ? ' ' + otherMaskAttribute.className : '').concat(show ? ' active' : ''),
    style: Object.assign({}, durationStyle, otherMaskAttribute.style || {}),
    onClick: handleClick,
    children: /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({
      "data-animation": animation
    }, others), {}, {
      className: "actionsheet".concat(animationClassName ? ' ' + animationClassName : '').concat(others.className ? ' ' + others.className : '').concat(show ? ' active' : ''),
      style: Object.assign({}, durationStyle, others.style || {}),
      children: [/*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, otherGroupAttribute), {}, {
        className: "actionsheet-group".concat(otherGroupAttribute.className ? ' ' + otherGroupAttribute.className : ''),
        children: list && list.map(function (item, index) {
          return /*#__PURE__*/_createElement("div", _objectSpread(_objectSpread({}, otherOptionAttribute), {}, {
            className: "actionsheet-option".concat(otherOptionAttribute.className ? ' ' + otherOptionAttribute.className : ' border-b'),
            key: index,
            "data-index": index
          }), item.name);
        })
      })), cancelAttribute.onClick && /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, otherCancelAttribute), {}, {
        className: "actionsheet-cancel".concat(otherCancelAttribute.className ? ' ' + otherCancelAttribute.className : ''),
        children: cancelCaption || locale('取消', 'cancel')
      }))]
    }))
  })), portal || context.portal || document.getElementById('root') || document.body);
});
export default Actionsheet;