function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["portal", "onHide", "onRecord", "maxDuration", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useContext, useRef, useImperativeHandle, useEffect, useState } from 'react';
import { createPortal } from 'react-dom';
import Context from "./../Context/instance.js";
import CameraRecorder from "./CameraRecorder.js";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Camera = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
    onHide = _ref.onHide,
    onRecord = _ref.onRecord,
    maxDuration = _ref.maxDuration,
    children = _ref.children,
    others = _objectWithoutProperties(_ref, _excluded);
  // context
  var context = useContext(Context) || {};
  var _useState = useState({}),
    _useState2 = _slicedToArray(_useState, 2),
    successResult = _useState2[0],
    setSuccessResult = _useState2[1];
  var videoRef = useRef(null);
  var startRef = useRef(null);
  var stopRef = useRef(null);
  var timeRef = useRef(null);
  var timeTargetRef = useRef(null);
  var successRef = useRef(null);
  var errorRef = useRef(null);
  var errorTargetRef = useRef(null);
  useImperativeHandle(ref, function () {
    return videoRef.current;
  });
  function openCamera() {
    CameraRecorder.init({
      maxDuration: maxDuration,
      timer: timeTargetRef.current,
      video: videoRef.current,
      onOpened: function onOpened(e, stream) {
        if (startRef.current) startRef.current.style.display = 'block';
        // e.target.play();
      },

      onStop: function onStop(e) {
        if (stopRef.current) stopRef.current.style.display = 'none';
        if (timeRef.current) timeRef.current.style.display = 'none';
        if (successRef.current) successRef.current.style.display = 'block';
        setSuccessResult(e);
      },
      onError: function onError(e, err) {
        if (errorRef.current) errorRef.current.style.display = 'block';
        if (errorTargetRef.current) errorTargetRef.current.innerHTML = err.errMsg;
      }
    });
  }
  function start() {
    CameraRecorder.startRecord();
    startRef.current.style.display = 'none';
    stopRef.current.style.display = 'block';
    timeRef.current.style.display = 'block';
  }
  function stop(e) {
    CameraRecorder.stopRecord();
  }
  function closeCamera(e) {
    CameraRecorder.stopRecord(null); // 关闭不走停止onStop回调
    if (onHide) onHide(e);
  }
  function success() {
    onRecord(successResult);
  }
  useEffect(function () {
    openCamera();
  }, []); // eslint-disable-line

  return /*#__PURE__*/createPortal( /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({
    ref: ref
  }, others), {}, {
    className: "camera".concat(others.className ? ' ' + others.className : ''),
    children: [/*#__PURE__*/_jsx("video", {
      ref: videoRef,
      width: "100%",
      height: "100%",
      autoPlay: "",
      playsInline: true,
      muted: true
    }), /*#__PURE__*/_jsx("div", {
      ref: startRef,
      className: "camera-recorder-start",
      onClick: start,
      children: /*#__PURE__*/_jsx("div", {
        className: "camera-recorder-start-round",
        children: /*#__PURE__*/_jsx("div", {
          className: "camera-recorder-start-dot"
        })
      })
    }), /*#__PURE__*/_jsx("div", {
      ref: stopRef,
      className: "camera-recorder-stop",
      onClick: stop,
      children: /*#__PURE__*/_jsx("div", {
        className: "camera-recorder-stop-dot"
      })
    }), /*#__PURE__*/_jsx("div", {
      ref: successRef,
      className: "camera-success",
      onClick: success,
      children: /*#__PURE__*/_jsx("div", {
        className: "camera-success-icon"
      })
    }), /*#__PURE__*/_jsxs("div", {
      ref: timeRef,
      className: "camera-recorder-timer",
      children: [/*#__PURE__*/_jsx("span", {
        className: "camera-recorder-timer-dot"
      }), /*#__PURE__*/_jsx("span", {
        ref: timeTargetRef,
        className: "camera-recorder-timer-label",
        children: "00:00"
      })]
    }), /*#__PURE__*/_jsx("div", {
      ref: errorRef,
      className: "camera-recorder-error",
      children: /*#__PURE__*/_jsx("span", {
        ref: errorTargetRef,
        className: "camera-recorder-error-label"
      })
    }), /*#__PURE__*/_jsx("div", {
      className: "camera-close",
      onClick: closeCamera
    }), children]
  })), portal || context.portal || document.getElementById('root') || document.body);
});
export default Camera;