function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["onTopRefresh", "onBottomRefresh", "refreshing", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect, useContext } from 'react';
import Container from "./../Container";
import Instance from "./instance.js";
import Context from "./../Context/instance.js";

/**
 * @deprecated since version 5.4.9
 * 请使用Body
 */
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var ContainerPull = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var onTopRefresh = _ref.onTopRefresh,
    onBottomRefresh = _ref.onBottomRefresh,
    refreshing = _ref.refreshing,
    children = _ref.children,
    others = _objectWithoutProperties(_ref, _excluded);
  // context
  var context = useContext(Context) || {};
  var locale = context.locale || function (remark) {
    return remark || '';
  };
  var rootRef = useRef(null);
  var topContainerRef = useRef(null);
  useImperativeHandle(ref, function () {
    return rootRef.current;
  });
  var instance = useRef(null);

  // 更新句柄, 防止synchronization模式, 每次组件在render的时候都生成上次render的state、function、effects
  if (instance.current) {
    // 头部刷新,加载第一页
    if (onTopRefresh) {
      instance.current.params.onTopRefresh = onTopRefresh;
    }
    // 底部刷新,加载下一页
    if (onBottomRefresh) {
      instance.current.params.onBottomRefresh = bottomRefresh;
    }
  }

  // 初始化
  if (refreshing === 0) refreshing = false;else if (refreshing === 1) refreshing = true;
  useEffect(function () {
    instance.current = new Instance({
      // threshold: 100,
      // end: 200, // 头部下拉的结束位置
      // endRefresh: null, // 滑动到指位置后自动刷新
      // moveTimeout: 0, // 滑动超时, 解决ios手指滑动到原生tabbar上, 不触发onTouchEnd
      container: rootRef.current,
      onScroll: others.onScroll ? others.onScroll : null,
      onTopRefresh: onTopRefresh,
      // 头部刷新,加载第一页
      onBottomRefresh: onBottomRefresh ? bottomRefresh : null,
      // 底部刷新,加载下一页
      // 构建实体
      topContainer: onTopRefresh ? topContainerRef.current : null,
      // 实体交互
      duration: 150,
      onPull: function onPull(e) {
        var topContainer = e.topContainer;
        topContainer.style.height = e.touches.currentPosY + 'px';
        var topIcon = topContainer.querySelector('.containerpull-pull-icon');
        var topCaption = topContainer.querySelector('.containerpull-pull-caption');
        if (!e.isLoading) {
          if (e.touches.currentPosY >= e.params.threshold) {
            if (topIcon) topIcon.classList.add('containerpull-pull-icon-down');
            if (topCaption) topCaption.innerHTML = locale('释放立即刷新', 'release');
          } else {
            if (topIcon) topIcon.classList.remove('containerpull-pull-icon-down');
            if (topCaption) topCaption.innerHTML = locale('下拉可以刷新', 'pull_down');
          }
        }
      },
      onShowTop: function onShowTop(e) {
        var topContainer = e.topContainer;
        var topIcon = topContainer.querySelector('.containerpull-pull-icon');
        var topCaption = topContainer.querySelector('.containerpull-pull-caption');
        topContainer.style.height = e.params.threshold + 'px';
        if (topIcon) topIcon.classList.remove('containerpull-pull-icon-down');
        if (topIcon) topIcon.classList.add('containerpull-pull-icon-loading');
        if (topCaption) topCaption.innerHTML = locale('正在刷新...', 'refreshing');
      },
      onHideTop: function onHideTop(e) {
        var topContainer = e.topContainer;
        topContainer.style.height = '0';
      },
      onTopHid: function onTopHid(e) {
        var topContainer = e.topContainer;
        var topIcon = topContainer.querySelector('.containerpull-pull-icon');
        if (topIcon) topIcon.classList.remove('containerpull-pull-icon-down');
        if (topIcon) topIcon.classList.remove('containerpull-pull-icon-loading');
      }
    });
  }, []); // eslint-disable-line

  // 刷新完成, 重置状态
  function refreshed() {
    instance.current.isLoading = false;
    if (instance.current.touches.posY) {
      // 如果头部展开, 则隐藏头部
      instance.current.hideTop(); // 隐藏头部
    }
  }

  // 底部刷新
  function bottomRefresh() {
    // 如果没有设置刷新状态refreshing, 则不刷新
    if (refreshing !== true && refreshing !== false) {
      refreshed();
      return;
    }
    // 正在刷新不触发底部刷新
    if (refreshing === true) return;
    // 刷新完成触发底部刷新
    if (refreshing === false) {
      onBottomRefresh();
    }
  }

  // 控制刷新
  var pullRefreshTimeout = useRef();
  useEffect(function () {
    if (!instance.current) return;
    // 如果没有设置刷新状态refreshing, 则不刷新
    if (refreshing !== true && refreshing !== false) {
      refreshed();
      return;
    }
    // 正在刷新
    if (refreshing === true) {
      instance.current.isLoading = true;
      return;
    }
    // 刷新完成
    if (refreshing === false) {
      // 刷新完成, 重置状态
      refreshed();
      // 判断是否没有滚动条, 如果没有滚动条会再次触发onBottomRefresh方法
      if (pullRefreshTimeout.current) {
        window.clearTimeout(pullRefreshTimeout.current);
      }
      // 底部刷新
      if (!onBottomRefresh) return;
      // 因为页面渲染需要时间, 所以需要等渲染完成后再判断有无滚动条
      pullRefreshTimeout.current = setTimeout(function () {
        if (!instance.current.hasScroll()) {
          console.log('刷新完成,但没有滚动条,继续加载...');
          bottomRefresh();
        } else if (instance.current.isBottom()) {
          console.log('刷新完成,滚动条在底部,继续加载...');
          bottomRefresh();
        }
      }, 500);
    }
  }, [refreshing]); // eslint-disable-line

  return /*#__PURE__*/_jsxs(Container, _objectSpread(_objectSpread({}, others), {}, {
    ref: rootRef,
    children: [/*#__PURE__*/_jsx("div", {
      ref: topContainerRef,
      className: "SID-Dragrefresh-TopContainer containerpull-pull",
      children: /*#__PURE__*/_jsxs("div", {
        className: "containerpull-pull-box",
        children: [/*#__PURE__*/_jsx("div", {
          className: "containerpull-pull-icon"
        }), /*#__PURE__*/_jsx("div", {
          className: "containerpull-pull-caption",
          children: locale('下拉可以刷新', 'pull_down')
        })]
      })
    }), children]
  }));
});
export default ContainerPull;