function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["visible", "value", "list", "multiple", "onSelect", "onBeforeChange", "onChange", "defaultPickerValue", "titleFormatter", "type", "min", "max", "onError", "ranges", "modal", "separator"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
// require PrototypeDate.js和PrototypeString.js
import React, { forwardRef, useEffect, useRef, useImperativeHandle } from 'react';
import locale from "./../../locale";
// 测试使用
// import locale from 'seedsui-react/lib/locale'
import { getFormat } from "./../utils";
import Instance from "./instance.js";
import Utils from "./Utils";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Main = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var visible = _ref.visible,
    value = _ref.value,
    list = _ref.list,
    multiple = _ref.multiple,
    onSelect = _ref.onSelect,
    onBeforeChange = _ref.onBeforeChange,
    onChange = _ref.onChange,
    defaultPickerValue = _ref.defaultPickerValue,
    titleFormatter = _ref.titleFormatter,
    _ref$type = _ref.type,
    type = _ref$type === void 0 ? 'date' : _ref$type,
    min = _ref.min,
    max = _ref.max,
    onError = _ref.onError,
    ranges = _ref.ranges,
    modal = _ref.modal,
    separator = _ref.separator,
    props = _objectWithoutProperties(_ref, _excluded);
  // 过滤非法的类型
  if (!['year', 'quarter', 'month', 'date', 'time', 'datetime'].includes(type)) {
    console.error("DatePicker.Modal: Wrong parameter with \"type\"! You need correct to ['year', 'quarter', 'month', 'date', 'time', 'datetime'] any one");
    // eslint-disable-next-line
    type = 'date';
  }

  // 节点
  var mainRef = useRef(null);
  var instance = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: mainRef.current,
      getRootDOM: function getRootDOM() {
        return mainRef.current;
      },
      instance: instance.current,
      getInstance: function getInstance() {
        return instance.current;
      },
      getValue: getValue,
      update: update,
      // 获取标题
      getTitle: function getTitle() {
        var _instance$current;
        if (instance !== null && instance !== void 0 && (_instance$current = instance.current) !== null && _instance$current !== void 0 && _instance$current.formatTitle) {
          var format = '';
          // 如果用户没有自定义标题格式, 则使用动态格式
          if (typeof titleFormatter === 'function') {
            format = titleFormatter({
              type: type,
              value: getValue(),
              ranges: ranges,
              separator: separator
            });
          }
          if (!format || typeof format !== 'string') {
            // 只有年月日、年月日时分才显示周几
            format = "".concat(getFormat(type)).concat(['date', 'datetime'].includes(type) ? ' 周EE' : '');
          }
          return instance.current.formatTitle(format);
        }
        return '';
      }
    };
  });

  // useEffect(() => {
  //   initInstance()
  //   // eslint-disable-next-line
  // }, [])

  useEffect(function () {
    update();
    // eslint-disable-next-line
  }, [value, type]);

  // 更新句柄, 防止synchronization模式, 每次组件在render的时候都生成上次render的state、function、effects
  if (instance.current) {
    instance.current.params.onScrollTransitionEnd = handleChange;
  }

  // 更新视图
  function update() {
    if (instance.current) {
      instance.current.updateParams({
        viewType: type,
        yyUnit: locale('', 'picker_unit_year'),
        QQUnit: locale('', 'picker_unit_quarter'),
        MMUnit: locale('', 'picker_unit_month'),
        ddUnit: locale('', 'picker_unit_date'),
        hhUnit: locale('', 'picker_unit_hour'),
        mmUnit: locale('', 'picker_unit_minute')
      });
      var def = Utils.getDefaults(value, defaultPickerValue);
      instance.current.setDefaults(def);
      instance.current.update();
    } else {
      initInstance();
    }
  }

  // 滚动结束
  function handleChange(s) {
    setTimeout(function () {
      // 根据月份算日
      if ((s.params.viewType === 'date' || s.params.viewType === 'datetime') && (s.activeSlot.index === 0 || s.activeSlot.index === 1)) {
        var year = s.activeOptions[0]['id'];
        var month = s.activeOptions[1]['id'];
        var defaultDay = s.activeOptions[2]['id'];
        s.updateDays(year, month, defaultDay); // 更新总天数
      }

      // 触发onChange事件
      if (onChange) onChange(getValue());
    }, 300);
  }

  // 获取选中值
  function getValue() {
    var s = instance.current;
    // 获取选中项
    var newValue = s.getActiveDate(s.activeOptions);
    var activeKeys = s.activeOptions.map(function (n, i, a) {
      return n['id'];
    });
    s.setDefaultsByKeys(activeKeys);
    return newValue;
  }

  // 实例化
  function initInstance() {
    if (!mainRef || !mainRef.current) return;
    var data = Utils.getData(list);
    var def = Utils.getDefaults(value, defaultPickerValue);
    // render数据
    instance.current = new Instance({
      wrapper: mainRef.current,
      viewType: type,
      yearsData: data.yearsData,
      quartersData: data.quartersData,
      monthsData: data.monthsData,
      daysData: data.daysData,
      hoursData: data.hoursData,
      minutesData: data.minutesData,
      defaultYear: def.year,
      defaultQuarter: def.quarter,
      defaultMonth: def.month,
      defaultDay: def.day,
      defaultHour: def.hour,
      defaultMinute: def.minute,
      onScrollTransitionEnd: handleChange,
      yyUnit: locale('', 'picker_unit_year'),
      // 年
      QQUnit: locale('', 'picker_unit_quarter'),
      // 季
      MMUnit: locale('', 'picker_unit_month'),
      // 月
      ddUnit: locale('', 'picker_unit_date'),
      // 日
      hhUnit: locale('', 'picker_unit_hour'),
      // 时
      mmUnit: locale('', 'picker_unit_minute') // 分
    });
  }

  return /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, props), {}, {
    className: "picker-main".concat(props.className ? ' ' + props.className : ''),
    ref: mainRef,
    children: [/*#__PURE__*/_jsx("div", {
      className: "picker-layer",
      children: /*#__PURE__*/_jsx("div", {
        className: "picker-layer-frame"
      })
    }), /*#__PURE__*/_jsx("div", {
      className: "picker-slotbox"
    })]
  }));
});
export default Main;