import { getDateDisplayValue } from "./../utils";
import getActiveKey from "./getActiveKey";

// 显示名称
function getRangeDisplayValue(_ref) {
  var format = _ref.format,
    ranges = _ref.ranges,
    type = _ref.type,
    value = _ref.value,
    separator = _ref.separator,
    currentActiveKey = _ref.currentActiveKey;
  if (!Array.isArray(value) || value.length !== 2) {
    return '';
  }
  var start = value[0];
  var end = value[1];
  if (Object.isDate(start) === false || Object.isDate(end) === false) {
    return '';
  }
  var displayValue = [];

  // 显示别名
  var activeKey = getActiveKey({
    value: value,
    ranges: ranges,
    type: type,
    currentActiveKey: currentActiveKey
  });
  if (activeKey) {
    return activeKey;
  }

  // 显示日期
  displayValue.push(getDateDisplayValue({
    format: format,
    type: type,
    value: start
  }));
  displayValue.push(getDateDisplayValue({
    format: format,
    type: type,
    value: end
  }));
  return displayValue.join(separator || ' ~ ');
}
export default getRangeDisplayValue;