import React, { forwardRef } from 'react';
import getCancelVisible from "./getCancelVisible";
import getSubmitVisible from "./getSubmitVisible";
import Cancel from "./Cancel";
import Submit from "./Submit";
import Caption from "./Caption";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Head = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var captionProps = _ref.captionProps,
    submitProps = _ref.submitProps,
    cancelProps = _ref.cancelProps,
    onSubmitClick = _ref.onSubmitClick,
    onCancelClick = _ref.onCancelClick;
  // 是否隐藏取消
  var cancelVisible = getCancelVisible(cancelProps, onCancelClick);
  // 是否隐藏确认, 隐藏确认按钮时, 取消按钮要在右侧显示
  var submitVisible = getSubmitVisible(submitProps, onSubmitClick);

  // 只显示标题
  if (!cancelVisible && !submitVisible) {
    return /*#__PURE__*/_jsx("div", {
      className: "picker-header",
      ref: ref,
      children: /*#__PURE__*/_jsx(Caption, {
        captionProps: captionProps
      })
    });
  }

  // 带按钮
  return /*#__PURE__*/_jsxs("div", {
    className: "picker-header",
    ref: ref,
    children: [/*#__PURE__*/_jsx("div", {
      className: "picker-header-button left",
      children: submitVisible && cancelVisible ? /*#__PURE__*/_jsx(Cancel, {
        cancelProps: cancelProps,
        onCancelClick: onCancelClick
      }) : null
    }), /*#__PURE__*/_jsx(Caption, {
      captionProps: captionProps
    }), /*#__PURE__*/_jsxs("div", {
      className: "picker-header-button right",
      children: [!submitVisible && cancelVisible ? /*#__PURE__*/_jsx(Cancel, {
        cancelProps: cancelProps,
        onCancelClick: onCancelClick
      }) : null, submitVisible && /*#__PURE__*/_jsx(Submit, {
        submitProps: submitProps,
        onSubmitClick: onSubmitClick
      })]
    })]
  });
});
export default Head;