function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["visible", "onVisibleChange", "portal", "animation", "maskProps", "captionProps", "submitProps", "cancelProps", "maskClosable", "children"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect } from 'react';
import { createPortal } from 'react-dom';
import Head from "./Head";

// Picker
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var Picker = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var visible = _ref.visible,
    onVisibleChange = _ref.onVisibleChange,
    portal = _ref.portal,
    _ref$animation = _ref.animation,
    animation = _ref$animation === void 0 ? 'slideUp' : _ref$animation,
    maskProps = _ref.maskProps,
    captionProps = _ref.captionProps,
    submitProps = _ref.submitProps,
    cancelProps = _ref.cancelProps,
    _ref$maskClosable = _ref.maskClosable,
    maskClosable = _ref$maskClosable === void 0 ? true : _ref$maskClosable,
    children = _ref.children,
    props = _objectWithoutProperties(_ref, _excluded);
  // 节点
  var modalRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: modalRef === null || modalRef === void 0 ? void 0 : modalRef.current,
      getRootDOM: function getRootDOM() {
        return modalRef.current;
      }
    };
  });
  useEffect(function () {
    if (onVisibleChange) onVisibleChange(visible);

    // eslint-disable-next-line
  }, [visible]);

  // 事件
  function handleCancelClick(e) {
    if (cancelProps !== null && cancelProps !== void 0 && cancelProps.onClick) cancelProps.onClick(e);
    if (onVisibleChange) onVisibleChange(false);
  }
  function handleMaskClick(e) {
    e.stopPropagation();
    if (!e.target.classList.contains('mask')) return;
    if (maskProps !== null && maskProps !== void 0 && maskProps.onClick) maskProps.onClick(e);
    if (maskClosable && onVisibleChange) onVisibleChange(false);
  }
  var Node = /*#__PURE__*/_jsx("div", _objectSpread(_objectSpread({}, maskProps), {}, {
    className: "mask picker-mask".concat(maskProps !== null && maskProps !== void 0 && maskProps.className ? ' ' + maskProps.className : '').concat(visible ? ' active' : ''),
    onClick: handleMaskClick,
    ref: modalRef,
    children: /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({
      "data-animation": animation
    }, props), {}, {
      className: "popup-animation picker".concat(props.className ? ' ' + props.className : '').concat(visible ? ' active' : ''),
      children: [/*#__PURE__*/_jsx(Head, {
        captionProps: captionProps,
        cancelProps: cancelProps,
        submitProps: submitProps,
        onCancelClick: handleCancelClick
      }), children]
    }))
  }));
  if (portal === null || portal === false) {
    return Node;
  }
  return /*#__PURE__*/createPortal(Node, portal || document.getElementById('root') || document.body);
});
export default Picker;