function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["src", "data", "params", "readOnly", "preview", "watermark", "onChange"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle, useEffect } from 'react';
import Instance from "./instance.js";
import BridgeBrowser from "./../Bridge/browser";
import locale from "./../locale";
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var loaded = 0; // eslint-disable-line

var Vott = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var src = _ref.src,
    _ref$data = _ref.data,
    data = _ref$data === void 0 ? [] : _ref$data,
    _ref$params = _ref.params,
    params = _ref$params === void 0 ? {} : _ref$params,
    _ref$readOnly = _ref.readOnly,
    readOnly = _ref$readOnly === void 0 ? true : _ref$readOnly,
    _ref$preview = _ref.preview,
    preview = _ref$preview === void 0 ? true : _ref$preview,
    watermark = _ref.watermark,
    onChange = _ref.onChange,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);
  var instance = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      instance: instance.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      },
      getInstance: function getInstance() {
        return instance.current;
      }
    };
  });
  useEffect(function () {
    if (instance.current) instance.current.updateParams(params);
    // eslint-disable-next-line
  }, [JSON.stringify(params)]);
  useEffect(function () {
    if (instance.current) instance.current.setReadOnly(readOnly);
  }, [readOnly]);
  useEffect(function () {
    if (instance.current) {
      instance.current.updateParams({
        src: src
      });
      loaded = 0;
      instance.current.update();
    }
  }, [src]);
  useEffect(function () {
    if (instance.current) {
      instance.current.updateParams({
        data: data
      });
      loaded = 0;
      instance.current.update();
    }
  }, [data]);
  useEffect(function () {
    instance.current = new Instance(rootRef.current, _objectSpread({
      readOnly: readOnly,
      data: data,
      src: src,
      // 图片加载成功
      onSuccess: handleSuccess,
      onChange: handleChange
    }, params));
  }, []); // eslint-disable-line

  // 更新句柄, 防止synchronization模式, 每次组件在render的时候都生成上次render的state、function、effects
  if (instance.current) {
    instance.current.params.onChange = handleChange;
  }
  function handleChange(s, item, list) {
    if (rootRef.current) s.currentTarget = rootRef.current;
    if (onChange) onChange(list, {
      current: item,
      instance: s
    });
  }
  function handleSuccess() {
    loaded = 1;
  }
  function handleClick() {
    previewImage();
  }
  function previewImage() {
    if (!readOnly || !preview || !loaded) return;
    // 克隆Wrapper
    var wrapper = instance.current.wrapper;
    var previewHTML = "<div class=\"preview-layer\"> <div class=\"vott-wrapper\">".concat(wrapper.innerHTML, "</div></div>");
    BridgeBrowser.previewImage({
      urls: [src],
      layerHTML: previewHTML,
      success: function success(s) {
        var layer = s.container.querySelector('.preview-layer');
        wrapper = s.container.querySelector('.vott-wrapper');
        var svg = wrapper.querySelector('.vott-svg');
        svg.style.backgroundImage = 'initial';
        // 计算宽高
        var width = svg.style.width.replace('px', '');
        var height = svg.style.height.replace('px', '');
        var scale = 1;
        if (width > height) {
          // 宽图计算
          scale = layer.clientWidth / width;
        } else {
          // 长图计算
          scale = layer.clientHeight / height;
        }
        wrapper.style.WebkitTransform = "scale(".concat(scale, ") translate(-50%,-50%)");
        wrapper.style.WebkitTransformOrigin = "0 0";
      }
    });
  }
  return /*#__PURE__*/_jsxs("div", _objectSpread(_objectSpread({}, props), {}, {
    className: "vott-container".concat(props.className ? ' ' + props.className : ''),
    ref: rootRef,
    children: [/*#__PURE__*/_jsxs("div", {
      className: "vott-wrapper",
      onClick: handleClick,
      children: [/*#__PURE__*/_jsx("svg", {
        className: "vott-svg",
        preserveAspectRatio: "none"
      }), watermark && /*#__PURE__*/_jsx("div", {
        className: "vott-watermark",
        style: {
          backgroundImage: "url(".concat(watermark, ")")
        }
      })]
    }), /*#__PURE__*/_jsx("div", {
      className: "vott-loading active",
      children: /*#__PURE__*/_jsx("div", {
        className: "vott-loading-icon"
      })
    }), /*#__PURE__*/_jsxs("div", {
      className: "vott-error",
      children: [/*#__PURE__*/_jsx("div", {
        className: "vott-error-icon"
      }), /*#__PURE__*/_jsx("div", {
        className: "vott-error-caption",
        children: locale('图片加载失败', 'hint_image_failed_to_load')
      })]
    })]
  }));
});
export default Vott;